Index: lib/3rdparty/freetype/include/freetype/internal/sfnt.h
===================================================================
--- lib/3rdparty/freetype/include/freetype/internal/sfnt.h	(révision 58413)
+++ lib/3rdparty/freetype/include/freetype/internal/sfnt.h	(copie de travail)
@@ -4,7 +4,7 @@
 /*                                                                         */
 /*    High-level `sfnt' driver interface (specification).                  */
 /*                                                                         */
-/*  Copyright 1996-2001, 2002, 2003, 2004, 2005, 2006 by                   */
+/*  Copyright 1996-2006, 2009, 2012 by                                     */
 /*  David Turner, Robert Wilhelm, and Werner Lemberg.                      */
 /*                                                                         */
 /*  This file is part of the FreeType project, and may only be used,       */
@@ -756,139 +756,216 @@
 #ifndef FT_CONFIG_OPTION_PIC
 
 #ifdef FT_CONFIG_OPTION_OLD_INTERNALS
-#define FT_DEFINE_DRIVERS_OLD_INTERNAL(a) \
-  a, 
+#define FT_DEFINE_DRIVERS_OLD_INTERNAL( a )  \
+          a,
 #else
-  #define FT_DEFINE_DRIVERS_OLD_INTERNAL(a)
+#define FT_DEFINE_DRIVERS_OLD_INTERNAL( a )  /* empty */
 #endif
-#define FT_INTERNAL(a) \
-  a, 
 
-#define FT_DEFINE_SFNT_INTERFACE(class_,                                     \
-    goto_table_, init_face_, load_face_, done_face_, get_interface_,         \
-    load_any_, load_sfnt_header_, load_directory_, load_head_,               \
-    load_hhea_, load_cmap_, load_maxp_, load_os2_, load_post_,               \
-    load_name_, free_name_, load_hdmx_stub_, free_hdmx_stub_,                \
-    load_kern_, load_gasp_, load_pclt_, load_bhed_,                          \
-    set_sbit_strike_stub_, load_sbits_stub_, find_sbit_image_,               \
-    load_sbit_metrics_, load_sbit_image_, free_sbits_stub_,                  \
-    get_psname_, free_psnames_, load_charmap_stub_, free_charmap_stub_,      \
-    get_kerning_, load_font_dir_, load_hmtx_, load_eblc_, free_eblc_,        \
-    set_sbit_strike_, load_strike_metrics_, get_metrics_ )                   \
-  static const SFNT_Interface class_ =                                       \
-  {                                                                          \
-    FT_INTERNAL(goto_table_) \
-    FT_INTERNAL(init_face_) \
-    FT_INTERNAL(load_face_) \
-    FT_INTERNAL(done_face_) \
-    FT_INTERNAL(get_interface_) \
-    FT_INTERNAL(load_any_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_sfnt_header_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_directory_) \
-    FT_INTERNAL(load_head_) \
-    FT_INTERNAL(load_hhea_) \
-    FT_INTERNAL(load_cmap_) \
-    FT_INTERNAL(load_maxp_) \
-    FT_INTERNAL(load_os2_) \
-    FT_INTERNAL(load_post_) \
-    FT_INTERNAL(load_name_) \
-    FT_INTERNAL(free_name_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_hdmx_stub_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(free_hdmx_stub_) \
-    FT_INTERNAL(load_kern_) \
-    FT_INTERNAL(load_gasp_) \
-    FT_INTERNAL(load_pclt_) \
-    FT_INTERNAL(load_bhed_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(set_sbit_strike_stub_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_sbits_stub_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(find_sbit_image_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_sbit_metrics_) \
-    FT_INTERNAL(load_sbit_image_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(free_sbits_stub_) \
-    FT_INTERNAL(get_psname_) \
-    FT_INTERNAL(free_psnames_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_charmap_stub_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(free_charmap_stub_) \
-    FT_INTERNAL(get_kerning_) \
-    FT_INTERNAL(load_font_dir_) \
-    FT_INTERNAL(load_hmtx_) \
-    FT_INTERNAL(load_eblc_) \
-    FT_INTERNAL(free_eblc_) \
-    FT_INTERNAL(set_sbit_strike_) \
-    FT_INTERNAL(load_strike_metrics_) \
-    FT_INTERNAL(get_metrics_) \
+#define FT_INTERNAL( a ) \
+          a,
+
+#define FT_DEFINE_SFNT_INTERFACE(                            \
+          class_,                                            \
+          goto_table_,                                       \
+          init_face_,                                        \
+          load_face_,                                        \
+          done_face_,                                        \
+          get_interface_,                                    \
+          load_any_,                                         \
+          load_sfnt_header_,                                 \
+          load_directory_,                                   \
+          load_head_,                                        \
+          load_hhea_,                                        \
+          load_cmap_,                                        \
+          load_maxp_,                                        \
+          load_os2_,                                         \
+          load_post_,                                        \
+          load_name_,                                        \
+          free_name_,                                        \
+          load_hdmx_stub_,                                   \
+          free_hdmx_stub_,                                   \
+          load_kern_,                                        \
+          load_gasp_,                                        \
+          load_pclt_,                                        \
+          load_bhed_,                                        \
+          set_sbit_strike_stub_,                             \
+          load_sbits_stub_,                                  \
+          find_sbit_image_,                                  \
+          load_sbit_metrics_,                                \
+          load_sbit_image_,                                  \
+          free_sbits_stub_,                                  \
+          get_psname_,                                       \
+          free_psnames_,                                     \
+          load_charmap_stub_,                                \
+          free_charmap_stub_,                                \
+          get_kerning_,                                      \
+          load_font_dir_,                                    \
+          load_hmtx_,                                        \
+          load_eblc_,                                        \
+          free_eblc_,                                        \
+          set_sbit_strike_,                                  \
+          load_strike_metrics_,                              \
+          get_metrics_ )                                     \
+  static const SFNT_Interface  class_ =                      \
+  {                                                          \
+    FT_INTERNAL( goto_table_ )                               \
+    FT_INTERNAL( init_face_ )                                \
+    FT_INTERNAL( load_face_ )                                \
+    FT_INTERNAL( done_face_ )                                \
+    FT_INTERNAL( get_interface_ )                            \
+    FT_INTERNAL( load_any_ )                                 \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_sfnt_header_ )      \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_directory_ )        \
+    FT_INTERNAL( load_head_ )                                \
+    FT_INTERNAL( load_hhea_ )                                \
+    FT_INTERNAL( load_cmap_ )                                \
+    FT_INTERNAL( load_maxp_ )                                \
+    FT_INTERNAL( load_os2_ )                                 \
+    FT_INTERNAL( load_post_ )                                \
+    FT_INTERNAL( load_name_ )                                \
+    FT_INTERNAL( free_name_ )                                \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_hdmx_stub_ )        \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( free_hdmx_stub_ )        \
+    FT_INTERNAL( load_kern_ )                                \
+    FT_INTERNAL( load_gasp_ )                                \
+    FT_INTERNAL( load_pclt_ )                                \
+    FT_INTERNAL( load_bhed_ )                                \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( set_sbit_strike_stub_ )  \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_sbits_stub_ )       \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( find_sbit_image_ )       \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_sbit_metrics_ )     \
+    FT_INTERNAL( load_sbit_image_ )                          \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( free_sbits_stub_ )       \
+    FT_INTERNAL( get_psname_ )                               \
+    FT_INTERNAL( free_psnames_ )                             \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_charmap_stub_ )     \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( free_charmap_stub_ )     \
+    FT_INTERNAL( get_kerning_ )                              \
+    FT_INTERNAL( load_font_dir_ )                            \
+    FT_INTERNAL( load_hmtx_ )                                \
+    FT_INTERNAL( load_eblc_ )                                \
+    FT_INTERNAL( free_eblc_ )                                \
+    FT_INTERNAL( set_sbit_strike_ )                          \
+    FT_INTERNAL( load_strike_metrics_ )                      \
+    FT_INTERNAL( get_metrics_ )                              \
   };
 
-#else /* FT_CONFIG_OPTION_PIC */ 
+#else /* FT_CONFIG_OPTION_PIC */
 
 #ifdef FT_CONFIG_OPTION_OLD_INTERNALS
-#define FT_DEFINE_DRIVERS_OLD_INTERNAL(a, a_) \
-  clazz->a = a_;
+#define FT_DEFINE_DRIVERS_OLD_INTERNAL( a, a_ )  \
+          clazz->a = a_;
 #else
-  #define FT_DEFINE_DRIVERS_OLD_INTERNAL(a, a_)
+#define FT_DEFINE_DRIVERS_OLD_INTERNAL( a, a_ )  /* empty */
 #endif
-#define FT_INTERNAL(a, a_) \
-  clazz->a = a_;
 
-#define FT_DEFINE_SFNT_INTERFACE(class_,                                     \
-    goto_table_, init_face_, load_face_, done_face_, get_interface_,         \
-    load_any_, load_sfnt_header_, load_directory_, load_head_,               \
-    load_hhea_, load_cmap_, load_maxp_, load_os2_, load_post_,               \
-    load_name_, free_name_, load_hdmx_stub_, free_hdmx_stub_,                \
-    load_kern_, load_gasp_, load_pclt_, load_bhed_,                          \
-    set_sbit_strike_stub_, load_sbits_stub_, find_sbit_image_,               \
-    load_sbit_metrics_, load_sbit_image_, free_sbits_stub_,                  \
-    get_psname_, free_psnames_, load_charmap_stub_, free_charmap_stub_,      \
-    get_kerning_, load_font_dir_, load_hmtx_, load_eblc_, free_eblc_,        \
-    set_sbit_strike_, load_strike_metrics_, get_metrics_ )                   \
-  void                                                                       \
-  FT_Init_Class_##class_( FT_Library library, SFNT_Interface*  clazz )       \
-  {                                                                          \
-    FT_UNUSED(library);                                                      \
-    FT_INTERNAL(goto_table,goto_table_) \
-    FT_INTERNAL(init_face,init_face_) \
-    FT_INTERNAL(load_face,load_face_) \
-    FT_INTERNAL(done_face,done_face_) \
-    FT_INTERNAL(get_interface,get_interface_) \
-    FT_INTERNAL(load_any,load_any_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_sfnt_header,load_sfnt_header_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_directory,load_directory_) \
-    FT_INTERNAL(load_head,load_head_) \
-    FT_INTERNAL(load_hhea,load_hhea_) \
-    FT_INTERNAL(load_cmap,load_cmap_) \
-    FT_INTERNAL(load_maxp,load_maxp_) \
-    FT_INTERNAL(load_os2,load_os2_) \
-    FT_INTERNAL(load_post,load_post_) \
-    FT_INTERNAL(load_name,load_name_) \
-    FT_INTERNAL(free_name,free_name_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_hdmx_stub,load_hdmx_stub_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(free_hdmx_stub,free_hdmx_stub_) \
-    FT_INTERNAL(load_kern,load_kern_) \
-    FT_INTERNAL(load_gasp,load_gasp_) \
-    FT_INTERNAL(load_pclt,load_pclt_) \
-    FT_INTERNAL(load_bhed,load_bhed_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(set_sbit_strike_stub,set_sbit_strike_stub_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_sbits_stub,load_sbits_stub_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(find_sbit_image,find_sbit_image_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_sbit_metrics,load_sbit_metrics_) \
-    FT_INTERNAL(load_sbit_image,load_sbit_image_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(free_sbits_stub,free_sbits_stub_) \
-    FT_INTERNAL(get_psname,get_psname_) \
-    FT_INTERNAL(free_psnames,free_psnames_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(load_charmap_stub,load_charmap_stub_) \
-    FT_DEFINE_DRIVERS_OLD_INTERNAL(free_charmap_stub,free_charmap_stub_) \
-    FT_INTERNAL(get_kerning,get_kerning_) \
-    FT_INTERNAL(load_font_dir,load_font_dir_) \
-    FT_INTERNAL(load_hmtx,load_hmtx_) \
-    FT_INTERNAL(load_eblc,load_eblc_) \
-    FT_INTERNAL(free_eblc,free_eblc_) \
-    FT_INTERNAL(set_sbit_strike,set_sbit_strike_) \
-    FT_INTERNAL(load_strike_metrics,load_strike_metrics_) \
-    FT_INTERNAL(get_metrics,get_metrics_) \
-  } 
+#define FT_INTERNAL( a, a_ )  \
+          clazz->a = a_;
 
-#endif /* FT_CONFIG_OPTION_PIC */ 
+#define FT_DEFINE_SFNT_INTERFACE(                             \
+          class_,                                             \
+          goto_table_,                                        \
+          init_face_,                                         \
+          load_face_,                                         \
+          done_face_,                                         \
+          get_interface_,                                     \
+          load_any_,                                          \
+          load_sfnt_header_,                                  \
+          load_directory_,                                    \
+          load_head_,                                         \
+          load_hhea_,                                         \
+          load_cmap_,                                         \
+          load_maxp_,                                         \
+          load_os2_,                                          \
+          load_post_,                                         \
+          load_name_,                                         \
+          free_name_,                                         \
+          load_hdmx_stub_,                                    \
+          free_hdmx_stub_,                                    \
+          load_kern_,                                         \
+          load_gasp_,                                         \
+          load_pclt_,                                         \
+          load_bhed_,                                         \
+          set_sbit_strike_stub_,                              \
+          load_sbits_stub_,                                   \
+          find_sbit_image_,                                   \
+          load_sbit_metrics_,                                 \
+          load_sbit_image_,                                   \
+          free_sbits_stub_,                                   \
+          get_psname_,                                        \
+          free_psnames_,                                      \
+          load_charmap_stub_,                                 \
+          free_charmap_stub_,                                 \
+          get_kerning_,                                       \
+          load_font_dir_,                                     \
+          load_hmtx_,                                         \
+          load_eblc_,                                         \
+          free_eblc_,                                         \
+          set_sbit_strike_,                                   \
+          load_strike_metrics_,                               \
+          get_metrics_ )                                      \
+  void                                                        \
+  FT_Init_Class_ ## class_( FT_Library       library,         \
+                            SFNT_Interface*  clazz )          \
+  {                                                           \
+    FT_UNUSED( library );                                     \
+                                                              \
+    FT_INTERNAL( goto_table, goto_table_ )                    \
+    FT_INTERNAL( init_face, init_face_ )                      \
+    FT_INTERNAL( load_face, load_face_ )                      \
+    FT_INTERNAL( done_face, done_face_ )                      \
+    FT_INTERNAL( get_interface, get_interface_ )              \
+    FT_INTERNAL( load_any, load_any_ )                        \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_sfnt_header,         \
+                                    load_sfnt_header_ )       \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_directory,           \
+                                    load_directory_ )         \
+    FT_INTERNAL( load_head, load_head_ )                      \
+    FT_INTERNAL( load_hhea, load_hhea_ )                      \
+    FT_INTERNAL( load_cmap, load_cmap_ )                      \
+    FT_INTERNAL( load_maxp, load_maxp_ )                      \
+    FT_INTERNAL( load_os2, load_os2_ )                        \
+    FT_INTERNAL( load_post, load_post_ )                      \
+    FT_INTERNAL( load_name, load_name_ )                      \
+    FT_INTERNAL( free_name, free_name_ )                      \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_hdmx_stub,           \
+                                    load_hdmx_stub_ )         \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( free_hdmx_stub,           \
+                                    free_hdmx_stub_ )         \
+    FT_INTERNAL( load_kern, load_kern_ )                      \
+    FT_INTERNAL( load_gasp, load_gasp_ )                      \
+    FT_INTERNAL( load_pclt, load_pclt_ )                      \
+    FT_INTERNAL( load_bhed, load_bhed_ )                      \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( set_sbit_strike_stub,     \
+                                    set_sbit_strike_stub_ )   \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_sbits_stub,          \
+                                    load_sbits_stub_ )        \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( find_sbit_image,          \
+                                    find_sbit_image_ )        \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_sbit_metrics,        \
+                                    load_sbit_metrics_ )      \
+    FT_INTERNAL( load_sbit_image, load_sbit_image_ )          \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( free_sbits_stub,          \
+                                    free_sbits_stub_ )        \
+    FT_INTERNAL( get_psname, get_psname_ )                    \
+    FT_INTERNAL( free_psnames, free_psnames_ )                \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( load_charmap_stub,        \
+                                    load_charmap_stub_ )      \
+    FT_DEFINE_DRIVERS_OLD_INTERNAL( free_charmap_stub,        \
+                                    free_charmap_stub_ )      \
+    FT_INTERNAL( get_kerning, get_kerning_ )                  \
+    FT_INTERNAL( load_font_dir, load_font_dir_ )              \
+    FT_INTERNAL( load_hmtx, load_hmtx_ )                      \
+    FT_INTERNAL( load_eblc, load_eblc_ )                      \
+    FT_INTERNAL( free_eblc, free_eblc_ )                      \
+    FT_INTERNAL( set_sbit_strike, set_sbit_strike_ )          \
+    FT_INTERNAL( load_strike_metrics, load_strike_metrics_ )  \
+    FT_INTERNAL( get_metrics, get_metrics_ )                  \
+  }
 
+#endif /* FT_CONFIG_OPTION_PIC */
+
 FT_END_HEADER
 
 #endif /* __SFNT_H__ */
Index: lib/3rdparty/freetype/include/freetype/internal/t1types.h
===================================================================
--- lib/3rdparty/freetype/include/freetype/internal/t1types.h	(révision 58413)
+++ lib/3rdparty/freetype/include/freetype/internal/t1types.h	(copie de travail)
@@ -5,7 +5,7 @@
 /*    Basic Type1/Type2 type definitions and interface (specification      */
 /*    only).                                                               */
 /*                                                                         */
-/*  Copyright 1996-2001, 2002, 2003, 2004, 2006, 2008, 2009 by             */
+/*  Copyright 1996-2004, 2006, 2008, 2009, 2011 by                         */
 /*  David Turner, Robert Wilhelm, and Werner Lemberg.                      */
 /*                                                                         */
 /*  This file is part of the FreeType project, and may only be used,       */
@@ -78,17 +78,6 @@
   } T1_EncodingRec, *T1_Encoding;
 
 
-  typedef enum  T1_EncodingType_
-  {
-    T1_ENCODING_TYPE_NONE = 0,
-    T1_ENCODING_TYPE_ARRAY,
-    T1_ENCODING_TYPE_STANDARD,
-    T1_ENCODING_TYPE_ISOLATIN1,
-    T1_ENCODING_TYPE_EXPERT
-
-  } T1_EncodingType;
-
-
   /* used to hold extra data of PS_FontInfoRec that
    * cannot be stored in the publicly defined structure.
    *
Index: lib/3rdparty/freetype/include/freetype/internal/tttypes.h
===================================================================
--- lib/3rdparty/freetype/include/freetype/internal/tttypes.h	(révision 58413)
+++ lib/3rdparty/freetype/include/freetype/internal/tttypes.h	(copie de travail)
@@ -5,7 +5,7 @@
 /*    Basic SFNT/TrueType type definitions and interface (specification    */
 /*    only).                                                               */
 /*                                                                         */
-/*  Copyright 1996-2001, 2002, 2004, 2005, 2006, 2007, 2008 by             */
+/*  Copyright 1996-2002, 2004-2008, 2012 by                                */
 /*  David Turner, Robert Wilhelm, and Werner Lemberg.                      */
 /*                                                                         */
 /*  This file is part of the FreeType project, and may only be used,       */
@@ -1401,7 +1401,7 @@
     FT_Byte*              vert_metrics;
     FT_ULong              vert_metrics_size;
 
-    FT_ULong              num_locations; /* in broken TTF, gid > 0xFFFF */ 
+    FT_ULong              num_locations; /* in broken TTF, gid > 0xFFFF */
     FT_Byte*              glyph_locations;
 
     FT_Byte*              hdmx_table;
@@ -1443,7 +1443,7 @@
   /*  <Fields>                                                             */
   /*     memory       :: A handle to the memory manager.                   */
   /*                                                                       */
-  /*     max_points   :: The maximal size in points of the zone.           */
+  /*     max_points   :: The maximum size in points of the zone.           */
   /*                                                                       */
   /*     max_contours :: Max size in links contours of the zone.           */
   /*                                                                       */
Index: lib/3rdparty/freetype/include/freetype/t1tables.h
===================================================================
--- lib/3rdparty/freetype/include/freetype/t1tables.h	(révision 58413)
+++ lib/3rdparty/freetype/include/freetype/t1tables.h	(copie de travail)
@@ -5,7 +5,7 @@
 /*    Basic Type 1/Type 2 tables definitions and interface (specification  */
 /*    only).                                                               */
 /*                                                                         */
-/*  Copyright 1996-2001, 2002, 2003, 2004, 2006, 2008, 2009 by             */
+/*  Copyright 1996-2004, 2006, 2008, 2009, 2011 by                         */
 /*  David Turner, Robert Wilhelm, and Werner Lemberg.                      */
 /*                                                                         */
 /*  This file is part of the FreeType project, and may only be used,       */
@@ -493,9 +493,167 @@
   FT_Get_PS_Font_Private( FT_Face     face,
                           PS_Private  afont_private );
 
+
+  /*************************************************************************/
+  /*                                                                       */
+  /* <Enum>                                                                */
+  /*    T1_EncodingType                                                    */
+  /*                                                                       */
+  /* <Description>                                                         */
+  /*    An enumeration describing the `Encoding' entry in a Type 1         */
+  /*    dictionary.                                                        */
+  /*                                                                       */
+  typedef enum  T1_EncodingType_
+  {
+    T1_ENCODING_TYPE_NONE = 0,
+    T1_ENCODING_TYPE_ARRAY,
+    T1_ENCODING_TYPE_STANDARD,
+    T1_ENCODING_TYPE_ISOLATIN1,
+    T1_ENCODING_TYPE_EXPERT
+
+  } T1_EncodingType;
+
+
+  /*************************************************************************/
+  /*                                                                       */
+  /* <Enum>                                                                */
+  /*    PS_Dict_Keys                                                       */
+  /*                                                                       */
+  /* <Description>                                                         */
+  /*    An enumeration used in calls to @FT_Get_PS_Font_Value to identify  */
+  /*    the Type~1 dictionary entry to retrieve.                           */
+  /*                                                                       */
+  typedef enum  PS_Dict_Keys_
+  {
+    /* conventionally in the font dictionary */
+    PS_DICT_FONT_TYPE,              /* FT_Byte         */
+    PS_DICT_FONT_MATRIX,            /* FT_Fixed        */
+    PS_DICT_FONT_BBOX,              /* FT_Fixed        */
+    PS_DICT_PAINT_TYPE,             /* FT_Byte         */
+    PS_DICT_FONT_NAME,              /* FT_String*      */
+    PS_DICT_UNIQUE_ID,              /* FT_Int          */
+    PS_DICT_NUM_CHAR_STRINGS,       /* FT_Int          */
+    PS_DICT_CHAR_STRING_KEY,        /* FT_String*      */
+    PS_DICT_CHAR_STRING,            /* FT_String*      */
+    PS_DICT_ENCODING_TYPE,          /* T1_EncodingType */
+    PS_DICT_ENCODING_ENTRY,         /* FT_String*      */
+
+    /* conventionally in the font Private dictionary */
+    PS_DICT_NUM_SUBRS,              /* FT_Int     */
+    PS_DICT_SUBR,                   /* FT_String* */
+    PS_DICT_STD_HW,                 /* FT_UShort  */
+    PS_DICT_STD_VW,                 /* FT_UShort  */
+    PS_DICT_NUM_BLUE_VALUES,        /* FT_Byte    */
+    PS_DICT_BLUE_VALUE,             /* FT_Short   */
+    PS_DICT_BLUE_FUZZ,              /* FT_Int     */
+    PS_DICT_NUM_OTHER_BLUES,        /* FT_Byte    */
+    PS_DICT_OTHER_BLUE,             /* FT_Short   */
+    PS_DICT_NUM_FAMILY_BLUES,       /* FT_Byte    */
+    PS_DICT_FAMILY_BLUE,            /* FT_Short   */
+    PS_DICT_NUM_FAMILY_OTHER_BLUES, /* FT_Byte    */
+    PS_DICT_FAMILY_OTHER_BLUE,      /* FT_Short   */
+    PS_DICT_BLUE_SCALE,             /* FT_Fixed   */
+    PS_DICT_BLUE_SHIFT,             /* FT_Int     */
+    PS_DICT_NUM_STEM_SNAP_H,        /* FT_Byte    */
+    PS_DICT_STEM_SNAP_H,            /* FT_Short   */
+    PS_DICT_NUM_STEM_SNAP_V,        /* FT_Byte    */
+    PS_DICT_STEM_SNAP_V,            /* FT_Short   */
+    PS_DICT_FORCE_BOLD,             /* FT_Bool    */
+    PS_DICT_RND_STEM_UP,            /* FT_Bool    */
+    PS_DICT_MIN_FEATURE,            /* FT_Short   */
+    PS_DICT_LEN_IV,                 /* FT_Int     */
+    PS_DICT_PASSWORD,               /* FT_Long    */
+    PS_DICT_LANGUAGE_GROUP,         /* FT_Long    */
+
+    /* conventionally in the font FontInfo dictionary */
+    PS_DICT_VERSION,                /* FT_String* */
+    PS_DICT_NOTICE,                 /* FT_String* */
+    PS_DICT_FULL_NAME,              /* FT_String* */
+    PS_DICT_FAMILY_NAME,            /* FT_String* */
+    PS_DICT_WEIGHT,                 /* FT_String* */
+    PS_DICT_IS_FIXED_PITCH,         /* FT_Bool    */
+    PS_DICT_UNDERLINE_POSITION,     /* FT_Short   */
+    PS_DICT_UNDERLINE_THICKNESS,    /* FT_UShort  */
+    PS_DICT_FS_TYPE,                /* FT_UShort  */
+    PS_DICT_ITALIC_ANGLE,           /* FT_Long    */
+
+    PS_DICT_MAX = PS_DICT_ITALIC_ANGLE
+
+  } PS_Dict_Keys;
+
+
+  /************************************************************************
+   *
+   * @function:
+   *    FT_Get_PS_Font_Value
+   *
+   * @description:
+   *    Retrieve the value for the supplied key from a PostScript font.
+   *
+   * @input:
+   *    face ::
+   *       PostScript face handle.
+   *
+   *    key ::
+   *       An enumeration value representing the dictionary key to retrieve.
+   *
+   *    idx ::
+   *       For array values, this specifies the index to be returned.
+   *
+   *    value ::
+   *       A pointer to memory into which to write the value.
+   *
+   *    valen_len ::
+   *       The size, in bytes, of the memory supplied for the value.
+   *
+   * @output:
+   *    value ::
+   *       The value matching the above key, if it exists.
+   *
+   * @return:
+   *    The amount of memory (in bytes) required to hold the requested
+   *    value (if it exists, -1 otherwise).
+   *
+   * @note:
+   *    The values returned are not pointers into the internal structures of
+   *    the face, but are `fresh' copies, so that the memory containing them
+   *    belongs to the calling application.  This also enforces the
+   *    `read-only' nature of these values, i.e., this function cannot be
+   *    used to manipulate the face.
+   *
+   *    `value' is a void pointer because the values returned can be of
+   *    various types.
+   *
+   *    If either `value' is NULL or `value_len' is too small, just the
+   *    required memory size for the requested entry is returned.
+   *
+   *    The `idx' parameter is used, not only to retrieve elements of, for
+   *    example, the FontMatrix or FontBBox, but also to retrieve name keys
+   *    from the CharStrings dictionary, and the charstrings themselves.  It
+   *    is ignored for atomic values.
+   *
+   *    PS_DICT_BLUE_SCALE returns a value that is scaled up by 1000.  To
+   *    get the value as in the font stream, you need to divide by
+   *    65536000.0 (to remove the FT_Fixed scale, and the x1000 scale).
+   *
+   *    IMPORTANT: Only key/value pairs read by the FreeType interpreter can
+   *    be retrieved.  So, for example, PostScript procedures such as NP,
+   *    ND, and RD are not available.  Arbitrary keys are, obviously, not be
+   *    available either.
+   *
+   *    If the font's format is not PostScript-based, this function returns
+   *    the `FT_Err_Invalid_Argument' error code.
+   *
+   */
+  FT_EXPORT( FT_Long )
+  FT_Get_PS_Font_Value( FT_Face       face,
+                        PS_Dict_Keys  key,
+                        FT_UInt       idx,
+                        void         *value,
+                        FT_Long       value_len );
+
   /* */
 
-
 FT_END_HEADER
 
 #endif /* __T1TABLES_H__ */
